diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/common-info-basic-mle.h ns-3.44/src/wifi/model/eht/common-info-basic-mle.h
--- ns-3.43/src/wifi/model/eht/common-info-basic-mle.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/wifi/model/eht/common-info-basic-mle.h	2025-03-09 16:55:49.783372600 -0700
@@ -0,0 +1,197 @@
+/*
+ * Copyright (c) 2021 Universita' degli Studi di Napoli Federico II
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef COMMON_INFO_BASIC_MLE_H
+#define COMMON_INFO_BASIC_MLE_H
+
+#include "ns3/buffer.h"
+#include "ns3/mac48-address.h"
+#include "ns3/nstime.h"
+
+#include <cstdint>
+#include <optional>
+
+namespace ns3
+{
+
+/**
+ * Common Info field of the Basic Multi-Link element.
+ * See Sec. 9.4.2.312.2.2 of 802.11be D1.5
+ */
+struct CommonInfoBasicMle
+{
+    /**
+     * Medium Synchronization Delay Information subfield
+     */
+    struct MediumSyncDelayInfo
+    {
+        uint8_t mediumSyncDuration;            //!< Medium Synchronization Duration
+        uint8_t mediumSyncOfdmEdThreshold : 4; //!< Medium Synchronization OFDM ED Threshold
+        uint8_t mediumSyncMaxNTxops : 4;       //!< Medium Synchronization MAximum Number of TXOPs
+    };
+
+    /**
+     * EML Capabilities subfield
+     */
+    struct EmlCapabilities
+    {
+        uint8_t emlsrSupport : 1;         //!< EMLSR Support
+        uint8_t emlsrPaddingDelay : 3;    //!< EMLSR Padding Delay
+        uint8_t emlsrTransitionDelay : 3; //!< EMLSR Transition Delay
+        uint8_t emlmrSupport : 1;         //!< EMLMR Support
+        uint8_t emlmrDelay : 3;           //!< EMLMR Delay
+        uint8_t transitionTimeout : 4;    //!< Transition Timeout
+    };
+
+    /**
+     * MLD Capabilities subfield
+     */
+    struct MldCapabilities
+    {
+        uint8_t maxNSimultaneousLinks : 4;   //!< Max number of simultaneous links
+        uint8_t srsSupport : 1;              //!< SRS Support
+        uint8_t tidToLinkMappingSupport : 2; //!< TID-To-Link Mapping Negotiation Supported
+        uint8_t freqSepForStrApMld : 5; //!< Frequency Separation For STR/AP MLD Type Indication
+        uint8_t aarSupport : 1;         //!< AAR Support
+    };
+
+    /**
+     * Extended MLD Capabilities and Operations subfield
+     */
+    struct ExtMldCapabilities
+    {
+        uint8_t opParamUpdateSupp : 1;    ///< Operation Parameter Update Support
+        uint8_t recommMaxSimulLinks : 4;  ///< Recommended Max Simultaneous Links
+        uint8_t nstrStatusUpdateSupp : 1; ///< NSTR Status Update Support
+    };
+
+    /**
+     * Subfields
+     */
+    Mac48Address m_mldMacAddress;                  //!< MLD MAC Address
+    std::optional<uint8_t> m_linkIdInfo;           //!< Link ID Info
+    std::optional<uint8_t> m_bssParamsChangeCount; //!< BSS Parameters Change Count
+    std::optional<MediumSyncDelayInfo>
+        m_mediumSyncDelayInfo;                        //!< Medium Synchronization Delay Information
+    std::optional<EmlCapabilities> m_emlCapabilities; //!< EML Capabilities
+    std::optional<MldCapabilities> m_mldCapabilities; //!< MLD Capabilities
+    std::optional<uint8_t> m_apMldId;                 ///< AP MLD ID
+    std::optional<ExtMldCapabilities> m_extMldCapabilities; ///< Extended MLD Capabilities
+
+    /**
+     * Get the Presence Bitmap subfield of the Common Info field
+     *
+     * @return the Presence Bitmap subfield of the Common Info field
+     */
+    uint16_t GetPresenceBitmap() const;
+
+    /**
+     * Get the size of the serialized Common Info field
+     *
+     * @return the size of the serialized Common Info field
+     */
+    uint8_t GetSize() const;
+
+    /**
+     * Serialize the Common Info field
+     *
+     * @param start iterator pointing to where the Common Info field should be written to
+     */
+    void Serialize(Buffer::Iterator& start) const;
+
+    /**
+     * Deserialize the Common Info field
+     *
+     * @param start iterator pointing to where the Common Info field should be read from
+     * @param presence the value of the Presence Bitmap field indicating which subfields
+     *                 are present in the Common Info field
+     * @return the number of bytes read
+     */
+    uint8_t Deserialize(Buffer::Iterator start, uint16_t presence);
+
+    /**
+     * @param delay the EMLSR Padding delay
+     * @return the encoded value for the EMLSR Padding Delay subfield
+     */
+    static uint8_t EncodeEmlsrPaddingDelay(Time delay);
+
+    /**
+     * @param value the value for the EMLSR Padding Delay subfield
+     * @return the corresponding EMLSR Padding delay
+     */
+    static Time DecodeEmlsrPaddingDelay(uint8_t value);
+
+    /**
+     * @param delay the EMLSR Transition delay
+     * @return the encoded value for the EMLSR Transition Delay subfield
+     */
+    static uint8_t EncodeEmlsrTransitionDelay(Time delay);
+
+    /**
+     * @param value the value for the EMLSR Transition Delay subfield
+     * @return the corresponding EMLSR Transition delay
+     */
+    static Time DecodeEmlsrTransitionDelay(uint8_t value);
+
+    /**
+     * Set the Medium Synchronization Duration subfield of the Medium Synchronization
+     * Delay Information in the Common Info field.
+     *
+     * @param delay the timer duration (must be a multiple of 32 microseconds)
+     */
+    void SetMediumSyncDelayTimer(Time delay);
+
+    /**
+     * Set the Medium Synchronization OFDM ED Threshold subfield of the Medium Synchronization
+     * Delay Information in the Common Info field.
+     *
+     * @param threshold the threshold in dBm (ranges from -72 to -62 dBm)
+     */
+    void SetMediumSyncOfdmEdThreshold(int8_t threshold);
+
+    /**
+     * Set the Medium Synchronization Maximum Number of TXOPs subfield of the Medium Synchronization
+     * Delay Information in the Common Info field. A value of zero indicates no limit on the
+     * maximum number of TXOPs.
+     *
+     * @param nTxops the maximum number of TXOPs a non-AP STA is allowed to attempt to
+     *               initiate while the MediumSyncDelay timer is running at a non-AP STA
+     */
+    void SetMediumSyncMaxNTxops(uint8_t nTxops);
+
+    /**
+     * Get the Medium Synchronization Duration subfield of the Medium Synchronization Delay
+     * Information in the Common Info field. Make sure that the Medium Synchronization Delay
+     * Information subfield is present.
+     *
+     * @return the timer duration
+     */
+    Time GetMediumSyncDelayTimer() const;
+
+    /**
+     * Get the Medium Synchronization OFDM ED Threshold in dBm. Make sure that the Medium
+     * Synchronization Delay Information subfield is present.
+     *
+     * @return the threshold in dBm
+     */
+    int8_t GetMediumSyncOfdmEdThreshold() const;
+
+    /**
+     * Get the maximum number of TXOPs a non-AP STA is allowed to attempt to initiate
+     * while the MediumSyncDelay timer is running at a non-AP STA. If no value is returned,
+     * no limit is imposed on the number of TXOPs. Make sure that the Medium Synchronization
+     * Delay Information subfield is present.
+     *
+     * @return the number of TXOPs
+     */
+    std::optional<uint8_t> GetMediumSyncMaxNTxops() const;
+};
+
+} // namespace ns3
+
+#endif /* COMMON_INFO_BASIC_MLE_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/common-info-probe-req-mle.cc ns-3.44/src/wifi/model/eht/common-info-probe-req-mle.cc
--- ns-3.43/src/wifi/model/eht/common-info-probe-req-mle.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/wifi/model/eht/common-info-probe-req-mle.cc	2025-03-09 16:55:49.783372600 -0700
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2024
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sharan Naribole <sharan.naribole@gmail.com>
+ */
+
+#include "common-info-probe-req-mle.h"
+
+#include "ns3/abort.h"
+
+namespace ns3
+{
+
+uint16_t
+CommonInfoProbeReqMle::GetPresenceBitmap() const
+{
+    // IEEE 802.11be D5.0 Figure 9-1072q
+    return (m_apMldId.has_value() ? 0x0001 : 0x0);
+}
+
+uint8_t
+CommonInfoProbeReqMle::GetSize() const
+{
+    uint8_t size = 1; // Common Info Length
+    size += (m_apMldId.has_value() ? 1 : 0);
+    return size;
+}
+
+void
+CommonInfoProbeReqMle::Serialize(Buffer::Iterator& start) const
+{
+    start.WriteU8(GetSize()); // Common Info Length
+    if (m_apMldId.has_value())
+    {
+        start.WriteU8(*m_apMldId);
+    }
+}
+
+uint8_t
+CommonInfoProbeReqMle::Deserialize(Buffer::Iterator start, uint16_t presence)
+{
+    auto i = start;
+    auto length = i.ReadU8();
+    uint8_t count = 1;
+
+    if (presence & 0x1)
+    {
+        m_apMldId = i.ReadU8();
+        count++;
+    }
+    NS_ABORT_MSG_IF(count != length,
+                    "Common Info Length (" << +length
+                                           << ") differs "
+                                              "from actual number of bytes read ("
+                                           << +count << ")");
+    return count;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/common-info-probe-req-mle.h ns-3.44/src/wifi/model/eht/common-info-probe-req-mle.h
--- ns-3.43/src/wifi/model/eht/common-info-probe-req-mle.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/wifi/model/eht/common-info-probe-req-mle.h	2025-03-09 16:55:49.783372600 -0700
@@ -0,0 +1,62 @@
+/*
+ * Copyright (c) 2024
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sharan Naribole <sharan.naribole@gmail.com>
+ */
+
+#ifndef COMMON_INFO_PROBE_REQ_MLE_H
+#define COMMON_INFO_PROBE_REQ_MLE_H
+
+#include "ns3/buffer.h"
+
+#include <cstdint>
+#include <optional>
+
+namespace ns3
+{
+
+/**
+ * Common Info field of Multi-link Element Probe Request variant.
+ * IEEE 802.11be D6.0 9.4.2.321.3
+ */
+struct CommonInfoProbeReqMle
+{
+    std::optional<uint8_t> m_apMldId; ///< AP MLD ID
+
+    /**
+     * Get the Presence Bitmap subfield of the Common Info field
+     *
+     * @return the Presence Bitmap subfield of the Common Info field
+     */
+    uint16_t GetPresenceBitmap() const;
+
+    /**
+     * Get the size of the serialized Common Info field
+     *
+     * @return the size of the serialized Common Info field
+     */
+    uint8_t GetSize() const;
+
+    /**
+     * Serialize the Common Info field
+     *
+     * @param start iterator pointing to where the Common Info field should be written to
+     */
+    void Serialize(Buffer::Iterator& start) const;
+
+    /**
+     * Deserialize the Common Info field
+     *
+     * @param start iterator pointing to where the Common Info field should be read from
+     * @param presence the value of the Presence Bitmap field indicating which subfields
+     *                 are present in the Common Info field
+     * @return the number of bytes read
+     */
+    uint8_t Deserialize(Buffer::Iterator start, uint16_t presence);
+};
+
+} // namespace ns3
+
+#endif // COMMON_INFO_PROBE_REQ_MLE_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/default-ap-emlsr-manager.h ns-3.44/src/wifi/model/eht/default-ap-emlsr-manager.h
--- ns-3.43/src/wifi/model/eht/default-ap-emlsr-manager.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/default-ap-emlsr-manager.h	2025-03-09 16:55:49.783372600 -0700
@@ -15,7 +15,7 @@
 {
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * DefaultApEmlsrManager is the default AP EMLSR manager.
  */
@@ -23,8 +23,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/default-emlsr-manager.cc ns-3.44/src/wifi/model/eht/default-emlsr-manager.cc
--- ns-3.43/src/wifi/model/eht/default-emlsr-manager.cc	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/default-emlsr-manager.cc	2025-03-09 16:55:49.787372600 -0700
@@ -41,19 +41,11 @@
                           "no PHY will be listening on that EMLSR link).",
                           BooleanValue(true),
                           MakeBooleanAccessor(&DefaultEmlsrManager::m_switchAuxPhy),
-                          MakeBooleanChecker())
-            .AddAttribute("PutAuxPhyToSleep",
-                          "Whether Aux PHY should be put into sleep mode while the Main PHY "
-                          "is operating on the same link as the Aux PHY (this only matters "
-                          "when the Aux PHY does not switch channel).",
-                          BooleanValue(true),
-                          MakeBooleanAccessor(&DefaultEmlsrManager::m_auxPhyToSleep),
                           MakeBooleanChecker());
     return tid;
 }
 
 DefaultEmlsrManager::DefaultEmlsrManager()
-    : m_mainPhySwitchInfo{}
 {
     NS_LOG_FUNCTION(this);
 }
@@ -96,19 +88,12 @@
 void
 DefaultEmlsrManager::NotifyMainPhySwitch(std::optional<uint8_t> currLinkId,
                                          uint8_t nextLinkId,
+                                         Ptr<WifiPhy> auxPhy,
                                          Time duration)
 {
-    NS_LOG_FUNCTION(this << (currLinkId ? std::to_string(*currLinkId) : "") << nextLinkId
+    NS_LOG_FUNCTION(this << (currLinkId ? std::to_string(*currLinkId) : "") << nextLinkId << auxPhy
                          << duration.As(Time::US));
 
-    // if currLinkId has no value (i.e., the main PHY is not operating on any link), it means that
-    // the main PHY is switching
-    const auto now = Simulator::Now();
-    NS_ASSERT_MSG(currLinkId || m_mainPhySwitchInfo.end >= now,
-                  "No current link ID provided nor valid main PHY switch information stored");
-    m_mainPhySwitchInfo.from = currLinkId.value_or(m_mainPhySwitchInfo.from);
-    m_mainPhySwitchInfo.end = now + duration;
-
     if (m_switchAuxPhy)
     {
         // cancel any previously requested aux PHY switch
@@ -123,51 +108,80 @@
 
         // schedule Aux PHY switch so that it operates on the link on which the main PHY was
         // operating
-        auto auxPhy = GetStaMac()->GetWifiPhy(nextLinkId);
-
         NS_LOG_DEBUG("Aux PHY (" << auxPhy << ") operating on link " << +nextLinkId
-                                 << " will switch to link " << +currLinkId.value() << " in "
+                                 << " will switch to link " << +m_mainPhySwitchInfo.from << " in "
                                  << duration.As(Time::US));
-
-        m_auxPhySwitchEvent =
-            Simulator::Schedule(duration, [=, this, prevLinkId = m_mainPhySwitchInfo.from]() {
-                SwitchAuxPhy(auxPhy, nextLinkId, prevLinkId);
-            });
+        SwitchAuxPhyAfterMainPhy(auxPhy, nextLinkId, m_mainPhySwitchInfo.from, duration);
         return;
     }
 
     if (currLinkId.has_value() && currLinkId != GetMainPhyId())
     {
-        // the main PHY is leaving a non-primary link, hence an aux PHY needs to be reconnected
+        // the main PHY is leaving an auxiliary link, hence an aux PHY needs to be reconnected
         NS_ASSERT_MSG(
             m_auxPhyToReconnect,
-            "There should be an aux PHY to reconnect when the main PHY leaves a non-primary link");
+            "There should be an aux PHY to reconnect when the main PHY leaves an auxiliary link");
 
         // the Aux PHY is not actually switching (hence no switching delay)
         GetStaMac()->NotifySwitchingEmlsrLink(m_auxPhyToReconnect, *currLinkId, Seconds(0));
-        // resume aux PHY from sleep (once reconnected to its original link)
-        m_auxPhyToReconnect->ResumeFromSleep();
         SetCcaEdThresholdOnLinkSwitch(m_auxPhyToReconnect, *currLinkId);
     }
 
     // if currLinkId has no value, it means that the main PHY switch is interrupted, hence reset
-    // the aux PHY to reconnect and cancel the event to put the aux PHY to sleep. Doing so when
-    // the main PHY is leaving the primary link makes no harm (the aux PHY to reconnect and the
-    // event to put the aux PHY to sleep are set below), thus no need to add an 'if' condition
+    // the aux PHY to reconnect. Doing so when the main PHY is leaving the preferred link makes
+    // no harm (the aux PHY to reconnect is set below), thus no need to add an 'if' condition
     m_auxPhyToReconnect = nullptr;
-    m_auxPhyToSleepEvent.Cancel();
 
     if (nextLinkId != GetMainPhyId())
     {
-        // the main PHY is moving to a non-primary link and the aux PHY does not switch link
-        m_auxPhyToReconnect = GetStaMac()->GetWifiPhy(nextLinkId);
+        // the main PHY is moving to an auxiliary link and the aux PHY does not switch link
+        m_auxPhyToReconnect = auxPhy;
+    }
+}
 
-        if (m_auxPhyToSleep)
-        {
-            // aux PHY can be put into sleep mode when the main PHY completes the channel switch
-            m_auxPhyToSleepEvent =
-                Simulator::Schedule(duration, &WifiPhy::SetSleepMode, m_auxPhyToReconnect);
-        }
+void
+DefaultEmlsrManager::SwitchAuxPhyAfterMainPhy(Ptr<WifiPhy> auxPhy,
+                                              uint8_t currLinkId,
+                                              uint8_t nextLinkId,
+                                              Time duration)
+{
+    NS_LOG_FUNCTION(this << auxPhy << currLinkId << nextLinkId << duration.As(Time::US));
+
+    if (duration.IsStrictlyPositive())
+    {
+        auto lambda = [=, this]() {
+            if (GetStaMac()->GetWifiPhy(currLinkId) == auxPhy)
+            {
+                // the aux PHY is still operating on the link, likely because it is receiving a
+                // PPDU and connecting the main PHY to the link has been postponed
+                const auto [maybeIcf, extension] = CheckPossiblyReceivingIcf(currLinkId);
+                if (maybeIcf && extension.IsStrictlyPositive())
+                {
+                    NS_LOG_DEBUG("Switching aux PHY to link " << +nextLinkId << " is postponed by "
+                                                              << extension.As(Time::US));
+                    SwitchAuxPhyAfterMainPhy(auxPhy, currLinkId, nextLinkId, extension);
+                    return;
+                }
+            }
+            const auto isSleeping = auxPhy->IsStateSleep();
+            if (isSleeping)
+            {
+                // if the aux PHY is sleeping, it cannot switch channel
+                auxPhy->ResumeFromSleep();
+            }
+            SwitchAuxPhy(auxPhy, currLinkId, nextLinkId);
+            if (isSleeping)
+            {
+                // sleep mode will be postponed until the end of channel switch
+                auxPhy->SetSleepMode(true);
+            }
+        };
+
+        m_auxPhySwitchEvent = Simulator::Schedule(duration, lambda);
+    }
+    else
+    {
+        SwitchAuxPhy(auxPhy, currLinkId, nextLinkId);
     }
 }
 
@@ -198,14 +212,17 @@
     // switch main PHY to the previous link, if needed
     if (!m_switchAuxPhy)
     {
-        SwitchMainPhyBackToPrimaryLink(linkId);
+        const auto mainPhy = GetStaMac()->GetDevice()->GetPhy(m_mainPhyId);
+        const auto delay = mainPhy->IsStateSwitching() ? mainPhy->GetDelayUntilIdle() : Time{0};
+        SwitchMainPhyBackToPreferredLink(linkId, EmlsrTxopEndedTrace(delay));
     }
 }
 
 void
-DefaultEmlsrManager::SwitchMainPhyBackToPrimaryLink(uint8_t linkId)
+DefaultEmlsrManager::SwitchMainPhyBackToPreferredLink(uint8_t linkId,
+                                                      EmlsrMainPhySwitchTrace&& traceInfo)
 {
-    NS_LOG_FUNCTION(this << linkId);
+    NS_LOG_FUNCTION(this << linkId << traceInfo.GetName());
 
     NS_ABORT_MSG_IF(m_switchAuxPhy, "This method can only be called when SwitchAuxPhy is false");
 
@@ -220,22 +237,30 @@
     // switching to a link on which an aux PHY gained a TXOP and sent an RTS, but the CTS
     // is not received and the UL TXOP ends before the main PHY channel switch is completed.
     // In such cases, wait until the main PHY channel switch is completed before requesting
-    // a new channel switch and cancel the event to put the aux PHY to sleep.
+    // a new channel switch.
     // Backoff shall not be reset on the link left by the main PHY because a TXOP ended and
     // a new backoff value must be generated.
     if (!mainPhy->IsStateSwitching())
     {
-        SwitchMainPhy(GetMainPhyId(), false, DONT_RESET_BACKOFF, REQUEST_ACCESS);
+        SwitchMainPhy(GetMainPhyId(),
+                      false,
+                      DONT_RESET_BACKOFF,
+                      REQUEST_ACCESS,
+                      std::forward<EmlsrMainPhySwitchTrace>(traceInfo));
     }
     else
     {
-        m_auxPhyToSleepEvent.Cancel();
-        Simulator::Schedule(mainPhy->GetDelayUntilIdle(), [=, this]() {
-            // request the main PHY to switch back to the primary link only if in the meantime
-            // no TXOP started on another link (which will require the main PHY to switch link)
+        Simulator::Schedule(mainPhy->GetDelayUntilIdle(), [=, info = traceInfo.Clone(), this]() {
+            // request the main PHY to switch back to the preferred link only if
+            // in the meantime no TXOP started on another link (which will
+            // require the main PHY to switch link)
             if (!GetEhtFem(linkId)->UsingOtherEmlsrLink())
             {
-                SwitchMainPhy(GetMainPhyId(), false, DONT_RESET_BACKOFF, REQUEST_ACCESS);
+                SwitchMainPhy(GetMainPhyId(),
+                              false,
+                              DONT_RESET_BACKOFF,
+                              REQUEST_ACCESS,
+                              std::move(*info));
             }
         });
     }
@@ -253,18 +278,29 @@
 {
     NS_LOG_FUNCTION(this << linkId);
 
+    const auto stationManager = GetStaMac()->GetWifiRemoteStationManager(linkId);
+    const auto bssid = GetEhtFem(linkId)->GetBssid();
+    const auto allowedWidth = GetEhtFem(linkId)->GetAllowedWidth();
+
+    return GetTimeToCtsEnd(linkId, stationManager->GetRtsTxVector(bssid, allowedWidth));
+}
+
+Time
+DefaultEmlsrManager::GetTimeToCtsEnd(uint8_t linkId, const WifiTxVector& rtsTxVector) const
+{
+    NS_LOG_FUNCTION(this << linkId << rtsTxVector);
+
     auto phy = GetStaMac()->GetWifiPhy(linkId);
     NS_ASSERT_MSG(phy, "No PHY operating on link " << +linkId);
 
-    // we have to check whether the main PHY can switch to take over the UL TXOP
     const auto stationManager = GetStaMac()->GetWifiRemoteStationManager(linkId);
     const auto bssid = GetEhtFem(linkId)->GetBssid();
-    const auto allowedWidth = GetEhtFem(linkId)->GetAllowedWidth();
-
-    const auto rtsTxVector = stationManager->GetRtsTxVector(bssid, allowedWidth);
-    const auto rtsTxTime = phy->CalculateTxDuration(GetRtsSize(), rtsTxVector, phy->GetPhyBand());
     const auto ctsTxVector = stationManager->GetCtsTxVector(bssid, rtsTxVector.GetMode());
-    const auto ctsTxTime = phy->CalculateTxDuration(GetCtsSize(), ctsTxVector, phy->GetPhyBand());
+
+    const auto rtsTxTime =
+        WifiPhy::CalculateTxDuration(GetRtsSize(), rtsTxVector, phy->GetPhyBand());
+    const auto ctsTxTime =
+        WifiPhy::CalculateTxDuration(GetCtsSize(), ctsTxVector, phy->GetPhyBand());
 
     // the main PHY shall terminate the channel switch at the end of CTS reception;
     // the time remaining to the end of CTS reception includes two propagation delays
@@ -277,7 +313,7 @@
     NS_LOG_FUNCTION(this << linkId);
 
     auto mainPhy = GetStaMac()->GetDevice()->GetPhy(m_mainPhyId);
-    auto timeToCtsEnd = GetTimeToCtsEnd(linkId);
+    const auto timeToCtsEnd = GetTimeToCtsEnd(linkId);
     auto switchingTime = mainPhy->GetChannelSwitchDelay();
 
     switch (mainPhy->GetState()->GetState())
@@ -303,21 +339,44 @@
         NS_ABORT_MSG("Main PHY cannot be in state " << mainPhy->GetState()->GetState());
     }
 
-    // TXOP can be started, schedule main PHY switch. Main PHY shall terminate the channel switch
-    // at the end of CTS reception
-    const auto delay = timeToCtsEnd - mainPhy->GetChannelSwitchDelay();
+    // TXOP can be started, main PHY will be scheduled to switch by NotifyRtsSent as soon as the
+    // transmission of the RTS is notified
+    m_switchMainPhyOnRtsTx[linkId] = Simulator::Now();
+
+    return {true, Time{0}};
+}
+
+void
+DefaultEmlsrManager::NotifyRtsSent(uint8_t linkId,
+                                   Ptr<const WifiPsdu> rts,
+                                   const WifiTxVector& txVector)
+{
+    NS_LOG_FUNCTION(this << *rts << txVector);
+
+    const auto it = m_switchMainPhyOnRtsTx.find(linkId);
+
+    if (it == m_switchMainPhyOnRtsTx.cend() || it->second != Simulator::Now())
+    {
+        // No request for main PHY to switch or obsolete request
+        return;
+    }
+
+    // Main PHY shall terminate the channel switch at the end of CTS reception
+    auto mainPhy = GetStaMac()->GetDevice()->GetPhy(m_mainPhyId);
+    const auto delay = GetTimeToCtsEnd(linkId, txVector) - mainPhy->GetChannelSwitchDelay();
+    NS_ASSERT_MSG(delay.IsPositive(),
+                  "RTS is being sent, but not enough time for main PHY to switch");
 
-    NS_ASSERT(delay.IsPositive());
     NS_LOG_DEBUG("Schedule main Phy switch in " << delay.As(Time::US));
-    m_ulMainPhySwitch[linkId] = Simulator::Schedule(delay,
-                                                    &DefaultEmlsrManager::SwitchMainPhy,
-                                                    this,
-                                                    linkId,
-                                                    false,
-                                                    RESET_BACKOFF,
-                                                    DONT_REQUEST_ACCESS);
+    m_ulMainPhySwitch[linkId] = Simulator::Schedule(delay, [=, this]() {
+        SwitchMainPhy(linkId,
+                      false,
+                      RESET_BACKOFF,
+                      DONT_REQUEST_ACCESS,
+                      EmlsrUlTxopRtsSentByAuxPhyTrace{});
+    });
 
-    return {true, Time{0}};
+    m_switchMainPhyOnRtsTx.erase(it);
 }
 
 } // namespace ns3
